﻿#ifndef AZEQ6_H
#define AZEQ6_H
#include "visusim.h"
#include "godialog.h"

class Azeq6 : public SimScene
{
    Q_OBJECT

public:
    friend class GoDialog;
    Azeq6();
    void redraw(void);
    void create();
    void setConfig(double *data);
    bool keyConfig(int, bool);

private:
    bool flagInfos;
    QFont font;
    int dimConf;
    double AziLum, SitLum, AziLumIni, SitLumIni;
    double sigma[4], sigDep[4], sigEnd[4]; // Razi, Rlat, Rah, Rdec
    GLuint Colonne, Etrier, SupEq6, CorpsEq6, Scope ;
    GLuint Boule;
    double DeltaA, size;
    QTimer *timerGo;
    int deltaT;         // intervalle rafraichissement en ms
    bool fgoto;         // goto en cours
    bool flagEnd;       // si but = END, sinon but = DEP
    bool fpause;        // pause en cours

    GoDialog *goDialog;

private slots:
    void gotoEnd(void);

};

#endif // AZEQ6_H
