#ifndef RUBICUB_H
#define RUBICUB_H
#include <GL/gl.h>
#include <GL/glu.h>

class Rubik;

typedef struct
{
    GLuint dl_cubes;                // Les display listes des 27 cubes de n=0 à 26 : dl_cubes+n
    double m44_cubes[27][16];       // Les matrice de situation des 27 cubes
    int index[27];                  // n = index[p] fournit le numéro n du cube occupant la place p.
    int facerot[6][9];              // facerot[f][0:8] fournit les numéros des 9 places de la face f.
} Rubicub;

#  ifdef __cplusplus
extern "C" {
#  endif


// Création des donnees d'un rubicube de taille "size"
Rubicub *glNewRubicub(double size);
// Libération des donnees du rubicube
void glDelRubicub(Rubicub *);
// Dessin du rubicube
void glDrawRubicub(Rubik *);

#  ifdef __cplusplus
}
#  endif


#endif // RUBICUB_H
