#ifndef RUBIK_H
#define RUBIK_H
#include "visusim.h"

#include "glrubicub.h"


class Rubik : public SimScene
{
    Q_OBJECT
public:
    Rubik();
    ~Rubik(){ glDelRubicub(r);}

    void redraw(void);
    void create();
    void setConfig(double *data);
    bool keyConfig(int, bool);
//    bool keyObserver(int, bool);

    Rubicub *r;
    int nHa, nAv, nDr;
private:
    int dimConf;
    double AngRot;          // Pour la rotation progressive
    int frottra ;           // Numero rotation en cours : rA, rA', rR, rR', rH, rH', rB, rB', rD, rD', rG, rG'
    int sensRot, iaxerot;   // Attribut rotation tranche en cours


    QTimer *timertra;
    int deltaT;                 // intervalle rafraichissement en ms
    QList<int*> listEnreg;    // liste des mouvements effectués
    bool enreg;                 // Etat deconstruction (vrai) ou reconstruction (false)

private slots:
    void rottra(void);
};

#endif // RUBIK_H
