#ifndef SACSO_H
#define SACSO_H

#include "visusim.h"

#define X_SELECT 1    /* Les touches modifient la position */
#define F_SELECT 2	  /* Les touches modifient les efforts */

class Sacso : public SimScene
{
    Q_OBJECT
public:
    Sacso();
    void redraw(void);
    void create();
    void setConfig(double *data);
    bool keyConfig(int key, bool majuscule);

private:
    QAction *actionForceOrPos;
    int fModeXouF;

    /*----------------------------------------------------------------------------------*/
    /* Description des objets dessinés (Dysplays Lists OpenGL)                          */
    /*----------------------------------------------------------------------------------*/
    GLuint DL_Corps;/* Corps du Mirage */
    GLuint DL_Aileron_D, DL_Aileron_G;/* Ailerons Mirage */
    GLuint DL_Cone;/* Pointe des flèches */
    GLuint DL_Poulie;/* Une poulie */
    GLuint DL_Veine;/* Veine soufflerie */
    double OA[12], Carol[3] ; /* Situation courante (xyz+mat33) et Carol en degrés  */
    double OAi[3*9];          /* Points de tangence cable sur les poulies / Ro */
    double Fxdes[6];
    double Qzero[9];
    int FlagNotiniConstSmp;
    int FlagExact;
    int meserrlec, mesdatnok;
    double T[9]; /* tensions courantes dans les cables */
    bool carolNok;
    void Geodir(double *Qi, double *A, double *OA, int FlagExact);


private slots:
    void ForceOrPosSlot();
};

#endif // SACSO_H
