#include "TexCube.h"
#include "../grafutils/qtglutils.h"
//#include "textbmap.h"
#include "mllglutil.h"

#include <math.h>
#ifndef M_PI
#define M_PI   3.14159265358979323846
#endif
#define RAD2DEG (180./M_PI)
#define DEG2RAD (M_PI/180.)

TexCube::TexCube()
{
    labelHelp->setWindowTitle("Aide Visu TexCube");

}

// Exemple avec un terrain plan fixe et un parallélépipède mobile
void TexCube::create()
{
    GLuint tex_Photos[6];
    double dsur2 = 1.5;

    /* Chargement des images texture */
#if 0
    tex_Photos[0] = TextureLoad("../visusim/texcube/image1.bmp", GL_FALSE, GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[1] = TextureLoad("../visusim/texcube/image3.bmp", GL_FALSE, GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[2] = TextureLoad("../visusim/texcube/image4.bmp", GL_FALSE, GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[3] = TextureLoad("../visusim/texcube/image5.bmp", GL_FALSE, GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[4] = TextureLoad("../visusim/texcube/image6.bmp", GL_FALSE, GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[5] = TextureLoad("../visusim/texcube/image7.bmp", GL_FALSE, GL_NEAREST, GL_NEAREST, GL_REPEAT);
#endif
    tex_Photos[0] = loadTexture(":/images/m51.jpg", GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[1] = loadTexture(":/images/m74.jpg", GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[2] = loadTexture(":/images/ngc1532.jpg", GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[3] = loadTexture(":/images/ngc3938.jpg", GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[4] = loadTexture(":/images/ngc6946.jpg", GL_NEAREST, GL_NEAREST, GL_REPEAT);
    tex_Photos[5] = loadTexture(":/images/ngc7479.jpg", GL_NEAREST, GL_NEAREST, GL_REPEAT);

    DL_TexCube = glGenLists(1);
    glNewList(DL_TexCube, GL_COMPILE);
    { /* crochet pour la lisibilité uniquement */
        glEnable(GL_TEXTURE_2D);
        glPushMatrix();
        // face Avant
        glBindTexture(GL_TEXTURE_2D, tex_Photos[0]);
        glBegin(GL_QUADS);
        glNormal3d(0.,0.,1.);
        glTexCoord2d(0.0, 1.0);
        glVertex3d(-dsur2, dsur2, dsur2);
        glTexCoord2d(0.0, 0.0);
        glVertex3d(-dsur2, -dsur2, dsur2);
        glTexCoord2d(1.0, 0.0);
        glVertex3d(dsur2,-dsur2, dsur2);
        glTexCoord2d(1.0, 1.0);
        glVertex3d(dsur2,dsur2, dsur2);
        glEnd();

        // face aRriere
        glBindTexture(GL_TEXTURE_2D, tex_Photos[1]);
        glBegin(GL_QUADS);
        glNormal3d(0.,0.,-1.);
        glTexCoord2d(0.0, 1.0);
        glVertex3d(dsur2,dsur2, -dsur2);
        glTexCoord2d(0.0, 0.0);
        glVertex3d(dsur2,-dsur2, -dsur2);
        glTexCoord2d(1.0, 0.0);
        glVertex3d(-dsur2, -dsur2, -dsur2);
        glTexCoord2d(1.0, 1.0);
        glVertex3d(-dsur2, dsur2, -dsur2);
        glEnd();

        // Top Face of Cube
        glBindTexture(GL_TEXTURE_2D, tex_Photos[2]);
        glBegin(GL_QUADS);
        glNormal3d(0.,1.,0.);
        glTexCoord2d(0.0, 1.0);
        glVertex3d(-dsur2, dsur2, dsur2);
        glTexCoord2d(0.0, 0.0);
        glVertex3d(dsur2, dsur2, dsur2);
        glTexCoord2d(1.0, 0.0);
        glVertex3d(dsur2, dsur2, -dsur2);
        glTexCoord2d(1.0, 1.0);
        glVertex3d(-dsur2, dsur2, -dsur2);
        glEnd();

        // Bottom Face of Cube
        glBindTexture(GL_TEXTURE_2D, tex_Photos[3]);
        glBegin(GL_QUADS);
        glNormal3d(0.,-1.,0.);
        glTexCoord2d(0.0, 1.0);
        glVertex3d(-dsur2, -dsur2, -dsur2);
        glTexCoord2d(0.0, 0.0);
        glVertex3d(dsur2, -dsur2, -dsur2);
        glTexCoord2d(1.0, 0.0);
        glVertex3d(dsur2, -dsur2, dsur2);
        glTexCoord2d(1.0, 1.0);
        glVertex3d(-dsur2, -dsur2, dsur2);
        glEnd();

        // Left hand side of cube
        glBindTexture(GL_TEXTURE_2D, tex_Photos[4]);
        glBegin(GL_QUADS);
        glNormal3d(-1.,0.,0.);
        glTexCoord2d(0.0, 1.0);
        glVertex3d(-dsur2, dsur2, -dsur2);
        glTexCoord2d(0.0, 0.0);
        glVertex3d(-dsur2, -dsur2, -dsur2);
        glTexCoord2d(1.0, 0.0);
        glVertex3d(-dsur2, -dsur2, dsur2);
        glTexCoord2d(1.0, 1.0);
        glVertex3d(-dsur2, dsur2, dsur2);
        glEnd();

        // Right hand side of cube
        glBindTexture(GL_TEXTURE_2D, tex_Photos[5]);
        glBegin(GL_QUADS);
        glNormal3d(1.,0.,0.);
        glTexCoord2d(0.0, 1.0);
        glVertex3d(dsur2, dsur2, dsur2);
        glTexCoord2d(0.0, 0.0);
        glVertex3d(dsur2, -dsur2, dsur2);
        glTexCoord2d(1.0, 0.0);
        glVertex3d(dsur2, -dsur2, -dsur2);
        glTexCoord2d(1.0, 1.0);
        glVertex3d(dsur2, dsur2, -dsur2);
        glEnd();
        glPopMatrix();
        glDisable(GL_TEXTURE_2D); // Important pour les autres objets
    }
    glEndList(); /* DL_TexCube */

    /* Initialisation des positions  */
    OA[0] = 0.;  //X
    OA[1] = 0.;   //Y
    OA[2] = 0.;   //Z
    Carol[0] = Carol[1] = Carol[2] = 0.;
    poscarNok = true;
    return ;
}

// Exemple de dessin de la scene exemple decrite ci-avant.
void TexCube::redraw(void)
{
    /* Les elements  */
    /* Transformations pour situation dans repere enginn */
    if(poscarNok)
    {
        double bid[3]; for(int i=0; i < 3; i++) bid[i] = Carol[i]*DEG2RAD;
        posEtcarol2mat44(sitOA44, OA, bid);
        poscarNok = false;
    }
    glMultMatrixd(sitOA44); /* On est dans le repere engin */
    glCallList(DL_TexCube);
}

// Réception des "dimConf" paramètres envoyés par le
// gestionnaire de l'avance de la simulation. Ici un exemple basique
// de reception des 6 paramètres X,Y,Z,L,T,R
void TexCube::setConfig(double *data)
{
    wGL->updateGL();
}

/*----------------------------------------------------------------------------------*/
/* Callback traitement touches pour actions diverses                                */
/* Peut être utilisée ou suchargée.                                                 */
/* x,X,y,Y,z,Z : modifie la position de la maquette cad le vecteur OA               */
/* l,L      : modifie le cap cad Carol[0]                                           */
/* t,T      : modifie l'assiette cad Carol[1]                                       */
/* r,R      : modifie le roulis cad Carol[2]                                        */
/* 0 ou o ou O : Retour à la configuration initiale                                 */
/*----------------------------------------------------------------------------------*/
bool TexCube::keyConfig(int key, bool majuscule)
{
    bool ok = FALSE;
    int maj = majuscule ? 1 : 0;
    int smaj = -1 + 2*maj;
    double DeltaA = 2.5, DeltaL = 0.05;

    switch (key)
    {
    case Qt::Key_0 : /* au centre */
    case Qt::Key_O : /* au centre */
        OA[0]=0.0;
        OA[1]=0.0;
        OA[2]=0.0;
        Carol[0]=0.0;
        Carol[1] =0.0;
        Carol[2]=0.0;
        poscarNok = true;
        ok = TRUE;
        break;
    case Qt::Key_X :
        OA[0] -= DeltaL*smaj ;
        poscarNok = true;
        ok = TRUE;
        break ;
    case Qt::Key_Y :
        OA[1] -= DeltaL*smaj ;
        poscarNok = true;
        ok = TRUE;
        break ;
    case Qt::Key_Z :
        OA[2] -= DeltaL*smaj ;
        poscarNok = true;
        ok = TRUE;
        break ;
    case Qt::Key_R : /* Roulis */
        Carol[2] -= DeltaA*smaj ;
        if (Carol[2]   >  180.0) Carol[2]   -= 360.0;
        if (Carol[2]   < -180.0) Carol[2]   += 360.0;
        poscarNok = true;
        ok = TRUE;
        break ;
    case Qt::Key_T : /* Assiette */
        Carol[1] -= DeltaA*smaj ;
        if (Carol[1] < -180.0) Carol[1] += 360. ;
        if (Carol[1] >  180.0) Carol[1] -= 360. ;
        poscarNok = true;
        ok = TRUE;
        break ;
    case Qt::Key_L : /* Cap */
        Carol[0] -= DeltaA*smaj ;
        if (Carol[0]      <    0.0) Carol[0]      += 360.0;
        if (Carol[0]      >  360.0) Carol[0]      -= 360.0;
        poscarNok = true;
        ok = TRUE;
        break ;
    }
    if (ok) wGL->updateGL();
    return ok;
}
